using FalcoEngine;

public class Crystal : MonoBehaviour
{
    public int crystalLevel = 1;
    public bool Killed = false;

    private Statistics stat;
    private CrystalsManager crystalsManager;
    private System.Random rnd = new System.Random();

    void Start()
    {
        stat = FindObjectOfType<Statistics>();
        crystalsManager = FindObjectOfType<CrystalsManager>();
    }

    void Update()
    {
        
        Rigidbody[] bodies = Physics.OverlapSphere(transform.position + gameObject.GetComponent<SphereCollider>().offset, gameObject.GetComponent<SphereCollider>().radius * 2f);

        foreach (Rigidbody b in bodies)
        {
            if (b.gameObject != gameObject)
            {
                if (b.gameObject.tag == gameObject.tag & crystalLevel < 10)
                {
                    if (!Killed)
                    {
                        FindObjectOfType<MusicPlayer>().PlayCrystalsSound();
                        b.gameObject.GetComponent<Crystal>().Killed = true;

                        stat.score += (int)Mathf.Pow(2, crystalLevel - 1);
                        GameObject cr = crystalsManager.crystals[crystalLevel].Instantiate(transform.position);

                        cr.rigidbody.linearVelocity += new Vector3(rnd.Next(-3, 3) * (float)rnd.NextDouble(), 3f, 0f);

                        Destroy(b.gameObject);
                        Destroy(gameObject);
                        break;
                    }
                }
            }
        }
    }

    void OnCollisionEnter(Collision col)
    {
        if (col.other.gameObject.name == "KillCube")
        {
            stat.status = "Killed";
        }
    }
}
